INTEGER FUNCTION SALDRV(HMODUL,NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
!
!-----------------------------------------------------------------------
!
!Purpose:
! code dependent operator driver for SAL.
!
!Copyright:
! Copyright (C) 2004 Ecole Polytechnique de Montreal
!
!Author(s): A. Hebert
!
!Parameters: input/output
! HMODUL  name of the operator.
! NENTRY  number of LCM objects or files used by the operator.
! HENTRY  name of each LCM object or file.
! IENTRY  type of each LCM object or file:
!         =1 LCM memory object; =2 XSM file; =3 sequential binary file;
!         =4 sequential ascii file.
! JENTRY  access of each LCM object or file:
!         =0 the LCM object or file is created;
!         =1 the LCM object or file is open for modifications;
!         =2 the LCM object or file is open in read-only mode.
! KENTRY  LCM object address or file unit number.
!
!Parameters: output
! SALDRV  completion flag (=0: operator HMODUL exists; =1: does not
!         exists).
!
!-----------------------------------------------------------------------
!
  USE GANLIB
!----
!  SUBROUTINE ARGUMENTS
!----
  INTEGER      NENTRY,IENTRY(NENTRY),JENTRY(NENTRY)
  TYPE(C_PTR)  KENTRY(NENTRY)
  CHARACTER    HMODUL*(*),HENTRY(NENTRY)*12
  REAL Tbeg,Tend
!
  SALDRV=0
  WRITE(*,*) 'SALDRV: IN ',HMODUL
  CALL KDRCPU(Tbeg)
  IF(HMODUL.EQ.'G2S:') THEN
     CALL G2S(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
  ELSE IF(HMODUL.EQ.'G2MC:') THEN
     CALL G2MC(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
  ELSE IF(HMODUL.EQ.'SALT:') THEN
     CALL SALT(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
  ELSE
      SALDRV=KDRDRV(HMODUL,NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
  ENDIF
  CALL KDRCPU(Tend)
  write(6,5000) HMODUL,(Tend-Tbeg)
 5000 format('-->>TIME SPENT IN MODULE ',A12,': ',F10.3)
END FUNCTION SALDRV
