*DECK TRCSPL
      SUBROUTINE TRCSPL(IMPX,IFOLD,IFNEW)
*
*-----------------------------------------------------------------------
*
*Purpose:
* split tracks with multiple reentry segments.
*
*Copyright:
* Copyright (C) 2014 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): A. Hebert
*
*Parameters: input/output
* IMPX    print parameter.
* IFOLD   existing tracking file unit with multiple reentry segments.
* IFNEW   new tracking file unit without multiple reentry segments.
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER IMPX,IFOLD,IFNEW
*----
*  LOCAL VARIABLES
*----
      CHARACTER CTRK*4,COMENT*80
      INTEGER, ALLOCATABLE, DIMENSION(:) :: MATALB,ICODE,NRSEG,NSPLIT
      REAL, ALLOCATABLE, DIMENSION(:) :: VOLSUR,GALBED,DENS,PATH
      REAL, ALLOCATABLE, DIMENSION(:,:) :: ANGLE
*----
*  FIRST PASS
*----
      REWIND(IFOLD)
      READ (IFOLD) CTRK,NCOMNT,NBTRK
      DO 10 IC=1,NCOMNT
         READ (IFOLD)
   10 CONTINUE
      READ(IFOLD) NDIM,ISPEC,NREG,NSOUT,NALBG,NCOR,NANGL,MXSEG
      READ(IFOLD)
      READ(IFOLD)
      READ(IFOLD)
      READ(IFOLD)
      READ(IFOLD)
      READ(IFOLD)
      ALLOCATE(NRSEG(MXSEG),PATH(MXSEG),NSPLIT(NBTRK))
      NBTRK2=0
      DO 20 ITRAK=1,NBTRK
         READ(IFOLD) IANG,LINE,WEIGHT,
     >               (NRSEG(IL),IL=1,LINE),(PATH(IL),IL=1,LINE)
         IF(LINE.GT.MXSEG) CALL XABORT('TRCSPL: MXSEG OVERFLOW.')
         IISPLIT=0
         DO IL=1,LINE
            IF(NRSEG(IL).LT.0) IISPLIT=IISPLIT+1
         ENDDO
         IF(MOD(IISPLIT,2).NE.0) CALL XABORT('TRCSPL: MOD FAILURE.')
         IF(IISPLIT.EQ.0) CALL XABORT('TRCSPL: NO SURFACE.')
         NSPLIT(ITRAK)=IISPLIT/2
         NBTRK2=NBTRK2+NSPLIT(ITRAK)
   20 CONTINUE
      IF(IMPX.GT.0) WRITE(6,100) NBTRK,NBTRK2
*----
*  SECOND PASS
*----
      REWIND(IFOLD)
      READ (IFOLD) CTRK,NCOMNT,NBTRK
      WRITE(IFNEW) CTRK,NCOMNT,NBTRK2
      DO 30 IC=1,NCOMNT
         READ (IFOLD) COMENT
         WRITE(IFNEW) COMENT
   30 CONTINUE
      READ(IFOLD) NDIM,ISPEC,NREG,NSOUT,NALBG,NCOR,NANGL,MXSEG
      ALLOCATE(VOLSUR(NSOUT+NREG+1),MATALB(NSOUT+NREG+1),ICODE(NALBG),
     > GALBED(NALBG),ANGLE(NDIM,NANGL),DENS(NANGL))
      READ(IFOLD) (VOLSUR(II),II=1,NSOUT+NREG+1)
      READ(IFOLD) (MATALB(II),II=1,NSOUT+NREG+1)
      READ(IFOLD) (ICODE(II),II=1,NALBG)
      READ(IFOLD) (GALBED(II),II=1,NALBG)
      READ(IFOLD) ((ANGLE(IDIM,II),IDIM=1,NDIM),II=1,NANGL)
      READ(IFOLD) (DENS(II),II=1,NANGL)
*
      WRITE(IFNEW) NDIM,ISPEC,NREG,NSOUT,NALBG,NCOR,NANGL,MXSEG
      WRITE(IFNEW) (VOLSUR(II),II=1,NSOUT+NREG+1)
      WRITE(IFNEW) (MATALB(II),II=1,NSOUT+NREG+1)
      WRITE(IFNEW) (ICODE(II),II=1,NALBG)
      WRITE(IFNEW) (GALBED(II),II=1,NALBG)
      WRITE(IFNEW) ((ANGLE(IDIM,II),IDIM=1,NDIM),II=1,NANGL)
      WRITE(IFNEW) (DENS(II),II=1,NANGL)
      DEALLOCATE(DENS,ANGLE,GALBED,ICODE,MATALB,VOLSUR)
      DO 40 ITRAK=1,NBTRK
         READ(IFOLD) IANG,LINE,WEIGHT,
     >               (NRSEG(IL),IL=1,LINE),(PATH(IL),IL=1,LINE)
         I1=1
         I2=1
         DO JTRAK=1,NSPLIT(ITRAK)
            I2=I1
            DO IL=I1+1,LINE
              IF(NRSEG(IL).LT.0) THEN
                I2=IL
                EXIT
              ENDIF
            ENDDO
            IF(I2.EQ.I1) CALL XABORT('TRCSPL: I2 FAILURE 1.')
            WRITE(IFNEW) IANG,I2-I1+1,WEIGHT,
     >                   (NRSEG(IL),IL=I1,I2),(PATH(IL),IL=I1,I2)
            I1=I2+1
         ENDDO
         IF(I2.NE.LINE) CALL XABORT('TRCSPL: I2 FAILURE 2.')
   40 CONTINUE
      DEALLOCATE(NSPLIT,PATH,NRSEG)
      RETURN
*
  100 FORMAT(/35H NUMBER OF TRACKS BEFORE SPLITTING=,I7/
     > 34H NUMBER OF TRACKS AFTER SPLITTING=,I7)
      END
